diff -ruN vdr-1.7.22/svdrpsend vdr-1.7.23/svdrpsend
--- vdr-1.7.22/svdrpsend	1970-01-01 01:00:00.000000000 +0100
+++ vdr-1.7.23/svdrpsend	2011-08-06 11:48:37.000000000 +0200
@@ -0,0 +1,57 @@
+#!/usr/bin/perl
+
+use Socket;
+use Getopt::Std;
+
+$Usage = qq{
+Usage: $0 options command...
+
+Options: -d hostname        destination hostname (default: localhost)
+         -p port            SVDRP port number (default: 6419)
+};
+
+die $Usage if (!$ARGV[0] || !getopts("d:p:"));
+
+$Dest = $opt_d  || "localhost";
+$Port = $opt_p  || 6419;
+$Cmd  = "@ARGV" || Error("missing command");
+
+$Timeout = 10; # max. seconds to wait for response
+
+$SIG{ALRM} = sub { Error("timeout"); };
+alarm($Timeout);
+
+$iaddr = inet_aton($Dest)                   || Error("no host: $Dest");
+$paddr = sockaddr_in($Port, $iaddr);
+
+$proto = getprotobyname('tcp');
+socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || Error("socket: $!");
+connect(SOCK, $paddr)                       || Error("connect: $!");
+select(SOCK); $| = 1;
+Receive();
+Send($Cmd);
+Send("quit");
+close(SOCK)                                 || Error("close: $!");
+
+sub Send
+{
+  my $cmd = shift || Error("no command to send");
+  print SOCK "$cmd\r\n";
+  Receive();
+}
+
+sub Receive
+{
+  while (<SOCK>) {
+        print STDOUT $_;
+        last if substr($_, 3, 1) ne "-";
+        }
+}
+
+sub Error
+{
+  print STDERR "@_\n";
+  close(SOCK);
+  exit 1;
+}
+
diff -ruN vdr-1.7.22/tools.c vdr-1.7.23/tools.c
--- vdr-1.7.22/tools.c	2011-12-04 15:52:38.000000000 +0100
+++ vdr-1.7.23/tools.c	2012-01-11 12:21:43.000000000 +0100
@@ -4,7 +4,7 @@
  * See the main source file 'vdr.c' for copyright information and
  * how to reach the author.
  *
- * $Id: tools.c 2.19 2011/12/04 14:52:38 kls Exp $
+ * $Id: tools.c 2.20 2012/01/11 11:21:43 kls Exp $
  */
 
 #include "tools.h"
@@ -1913,7 +1913,7 @@
 
 void cListBase::Move(cListObject *From, cListObject *To)
 {
-  if (From && To) {
+  if (From && To && From != To) {
      if (From->Index() < To->Index())
         To = To->Next();
      if (From == objects)
